/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest{}

// AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest struct for AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest
type AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest struct {
	Config []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner `json:"config,omitempty"`
}

// NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest instantiates a new AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest {
	this := AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest{}
	return &this
}

// NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestWithDefaults instantiates a new AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestWithDefaults() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest {
	this := AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest{}
	return &this
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) GetConfig() []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner {
	if o == nil || IsNil(o.Config) {
		var ret []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner
		return ret
	}
	return o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) GetConfigOk() ([]AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner and assigns it to the Config field.
func (o *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) SetConfig(v []AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequestConfigInner) {
	o.Config = v
}

func (o AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	return toSerialize, nil
}

type NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest struct {
	value *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest
	isSet bool
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) Get() *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest {
	return v.value
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) Set(val *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest(val *AppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest {
	return &NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerGoogleSheetsGoogleSheetsAuthorizerOAuthRequestURLRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
